]> git.ipfire.org Git - thirdparty/git.git/blame - git-submodule.sh
branch: don't mix --edit-description
[thirdparty/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
68cabbfd
DL
8USAGE="[--quiet] [--cached]
9 or: $dashless [--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 10 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 11 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 12 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
132f600b 13 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--[no-]single-branch] [--] [<path>...]
b57e8119 14 or: $dashless [--quiet] set-branch (--default|--branch <branch>) [--] <path>
26b06100 15 or: $dashless [--quiet] set-url [--] <path> <newurl>
adc54235 16 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 17 or: $dashless [--quiet] foreach [--recursive] <command>
c32eaa8a
SB
18 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
19 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
8f321a39 20OPTIONS_SPEC=
091a6eb0 21SUBDIRECTORY_OK=Yes
70c7ac22 22. git-sh-setup
98fcf840 23. git-parse-remote
70c7ac22 24require_work_tree
091a6eb0
JK
25wt_prefix=$(git rev-parse --show-prefix)
26cd_to_toplevel
70c7ac22 27
f1762d77
BW
28# Tell the rest of git that any URLs we get don't come
29# directly from the user, so it can apply policy as appropriate.
30GIT_PROTOCOL_FROM_USER=0
31export GIT_PROTOCOL_FROM_USER
33cfccbb 32
5c08dbbd 33command=
ecda0723 34branch=
d27b876b 35force=
d92a3959 36reference=
70c7ac22 37cached=
48bb3033
GP
38recursive=
39init=
0060fd15 40require_init=
1c244f6e 41files=
06b1abb5 42remote=
31ca3ac3 43nofetch=
32948425 44update=
15fc56a8 45prefix=
73b0898d 46custom_name=
275cd184 47depth=
72c5f883 48progress=
a0ef2934 49dissociate=
132f600b 50single_branch=
70c7ac22 51
be9d0a3a
HV
52die_if_unmatched ()
53{
54 if test "$1" = "#unmatched"
55 then
c4c02bf1 56 exit ${2:-1}
be9d0a3a
HV
57 fi
58}
59
88ce00c3
TK
60#
61# Print a submodule configuration setting
62#
63# $1 = submodule name
64# $2 = option name
65# $3 = default value
66#
67# Checks in the usual git-config places first (for overrides),
68# otherwise it falls back on .gitmodules. This allows you to
69# distribute project-wide defaults in .gitmodules, while still
70# customizing individual repositories if necessary. If the option is
71# not in .gitmodules either, print a default value.
72#
73get_submodule_config () {
74 name="$1"
75 option="$2"
76 default="$3"
77 value=$(git config submodule."$name"."$option")
78 if test -z "$value"
79 then
b2faad44 80 value=$(git submodule--helper config submodule."$name"."$option")
88ce00c3
TK
81 fi
82 printf '%s' "${value:-$default}"
83}
84
862ae6cd
RS
85isnumber()
86{
87 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
88}
89
dda63468 90# Given a full hex object ID, is this the zero OID?
91is_zero_oid () {
92 echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
93}
94
14111fc4
JK
95# Sanitize the local git environment for use within a submodule. We
96# can't simply use clear_local_git_env since we want to preserve some
97# of the settings from GIT_CONFIG_PARAMETERS.
98sanitize_submodule_env()
99{
89044baa 100 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 101 clear_local_git_env
89044baa 102 GIT_CONFIG_PARAMETERS=$save_config
860cba61 103 export GIT_CONFIG_PARAMETERS
14111fc4
JK
104}
105
ecda0723
SV
106#
107# Add a new submodule to the working tree, .gitmodules and the index
108#
ec05df35 109# $@ = repo path
ecda0723
SV
110#
111# optional branch is stored in global branch variable
112#
23a485e3 113cmd_add()
ecda0723 114{
5c08dbbd 115 # parse $args after "submodule ... add".
091a6eb0 116 reference_path=
5c08dbbd
JH
117 while test $# -ne 0
118 do
119 case "$1" in
120 -b | --branch)
121 case "$2" in '') usage ;; esac
122 branch=$2
123 shift
124 ;;
d27b876b
JL
125 -f | --force)
126 force=$1
127 ;;
5c08dbbd 128 -q|--quiet)
2e6a30ef 129 GIT_QUIET=1
5c08dbbd 130 ;;
6d33e1c2
CF
131 --progress)
132 progress=1
133 ;;
d92a3959
MT
134 --reference)
135 case "$2" in '') usage ;; esac
091a6eb0 136 reference_path=$2
d92a3959
MT
137 shift
138 ;;
139 --reference=*)
091a6eb0 140 reference_path="${1#--reference=}"
d92a3959 141 ;;
a0ef2934
CF
142 --dissociate)
143 dissociate=1
144 ;;
73b0898d
JL
145 --name)
146 case "$2" in '') usage ;; esac
147 custom_name=$2
148 shift
149 ;;
275cd184
FG
150 --depth)
151 case "$2" in '') usage ;; esac
152 depth="--depth=$2"
153 shift
154 ;;
155 --depth=*)
156 depth=$1
157 ;;
5c08dbbd
JH
158 --)
159 shift
160 break
161 ;;
162 -*)
163 usage
164 ;;
165 *)
166 break
167 ;;
168 esac
169 shift
170 done
171
76e9bdc4
AO
172 if ! git submodule--helper config --check-writeable >/dev/null 2>&1
173 then
174 die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
175 fi
176
091a6eb0
JK
177 if test -n "$reference_path"
178 then
179 is_absolute_path "$reference_path" ||
180 reference_path="$wt_prefix$reference_path"
181
182 reference="--reference=$reference_path"
183 fi
184
ecda0723 185 repo=$1
64394e3a 186 sm_path=$2
ecda0723 187
64394e3a 188 if test -z "$sm_path"; then
6a066230 189 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
190 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
191 fi
192
496eeeb1 193 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
194 usage
195 fi
196
091a6eb0
JK
197 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
198
ec05df35
ML
199 # assure repo is absolute or relative to parent
200 case "$repo" in
201 ./*|../*)
091a6eb0
JK
202 test -z "$wt_prefix" ||
203 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
204
ec05df35 205 # dereference source url relative to parent's url
63e95beb 206 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
207 ;;
208 *:*|/*)
209 # absolute url
210 realrepo=$repo
211 ;;
212 *)
497ee872 213 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
214 ;;
215 esac
216
db75ada5
MG
217 # normalize path:
218 # multiple //; leading ./; /./; /../; trailing /
64394e3a 219 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
220 sed -e '
221 s|//*|/|g
222 s|^\(\./\)*||
8196e728 223 s|/\(\./\)*|/|g
db75ada5
MG
224 :start
225 s|\([^/]*\)/\.\./||
226 tstart
227 s|/*$||
228 ')
619acfc7
SB
229 if test -z "$force"
230 then
231 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
232 die "$(eval_gettext "'\$sm_path' already exists in the index")"
233 else
234 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
235 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
236 fi
ecda0723 237
e1381118
KM
238 if test -d "$sm_path" &&
239 test -z $(git -C "$sm_path" rev-parse --show-cdup 2>/dev/null)
240 then
241 git -C "$sm_path" rev-parse --verify -q HEAD >/dev/null ||
242 die "$(eval_gettext "'\$sm_path' does not have a commit checked out")"
243 fi
244
c8163854 245 if test -z "$force"
d27b876b 246 then
c8163854
KM
247 dryerr=$(git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" 2>&1 >/dev/null)
248 res=$?
249 if test $res -ne 0
250 then
251 echo >&2 "$dryerr"
252 exit $res
253 fi
d27b876b
JL
254 fi
255
73b0898d
JL
256 if test -n "$custom_name"
257 then
258 sm_name="$custom_name"
259 else
260 sm_name="$sm_path"
261 fi
262
0383bbb9
JK
263 if ! git submodule--helper check-name "$sm_name"
264 then
265 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
266 fi
267
d4264ca3 268 # perhaps the path exists and is already a git repo, else clone it
64394e3a 269 if test -e "$sm_path"
d4264ca3 270 then
496eeeb1 271 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 272 then
64394e3a 273 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 274 else
64394e3a 275 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 276 fi
c2f93917 277
d4264ca3 278 else
4b7c286e
JL
279 if test -d ".git/modules/$sm_name"
280 then
281 if test -z "$force"
282 then
0d71dbfd 283 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
4b7c286e 284 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
0d71dbfd
VA
285 die "$(eval_gettextln "\
286If you want to reuse this local git directory instead of cloning again from
287 \$realrepo
288use the '--force' option. If the local git directory is not the correct repo
289or you are unsure what this means choose another name with the '--name' option.")"
4b7c286e 290 else
0d71dbfd 291 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
4b7c286e
JL
292 fi
293 fi
a0ef2934 294 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
d851ffb9 295 (
14111fc4 296 sanitize_submodule_env
d851ffb9
JH
297 cd "$sm_path" &&
298 # ash fails to wordsplit ${branch:+-b "$branch"...}
299 case "$branch" in
300 '') git checkout -f -q ;;
301 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
302 esac
303 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 304 fi
73b0898d 305 git config submodule."$sm_name".url "$realrepo"
d4264ca3 306
53213994 307 git add --no-warn-embedded-repo $force "$sm_path" ||
64394e3a 308 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 309
b2faad44
AO
310 git submodule--helper config submodule."$sm_name".path "$sm_path" &&
311 git submodule--helper config submodule."$sm_name".url "$repo" &&
b9289227
TK
312 if test -n "$branch"
313 then
b2faad44 314 git submodule--helper config submodule."$sm_name".branch "$branch"
b9289227 315 fi &&
31991b02 316 git add --force .gitmodules ||
64394e3a 317 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
1b614c07
BW
318
319 # NEEDSWORK: In a multi-working-tree world, this needs to be
320 # set in the per-worktree config.
321 if git config --get submodule.active >/dev/null
322 then
323 # If the submodule being adding isn't already covered by the
324 # current configured pathspec, set the submodule's active flag
325 if ! git submodule--helper is-active "$sm_path"
326 then
327 git config submodule."$sm_name".active "true"
328 fi
329 else
330 git config submodule."$sm_name".active "true"
331 fi
ecda0723
SV
332}
333
19a31f9c
ML
334#
335# Execute an arbitrary command sequence in each checked out
336# submodule
337#
338# $@ = command to execute
339#
340cmd_foreach()
341{
1d5bec8b
JH
342 # parse $args after "submodule ... foreach".
343 while test $# -ne 0
344 do
345 case "$1" in
346 -q|--quiet)
347 GIT_QUIET=1
348 ;;
15fc56a8
JH
349 --recursive)
350 recursive=1
351 ;;
1d5bec8b
JH
352 -*)
353 usage
354 ;;
355 *)
356 break
357 ;;
358 esac
359 shift
360 done
361
a282f5a9 362 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
19a31f9c
ML
363}
364
70c7ac22 365#
211b7f19 366# Register submodules in .git/config
70c7ac22
LH
367#
368# $@ = requested paths (default to all)
369#
23a485e3 370cmd_init()
70c7ac22 371{
5c08dbbd
JH
372 # parse $args after "submodule ... init".
373 while test $# -ne 0
374 do
375 case "$1" in
376 -q|--quiet)
2e6a30ef 377 GIT_QUIET=1
5c08dbbd
JH
378 ;;
379 --)
380 shift
381 break
382 ;;
383 -*)
384 usage
385 ;;
386 *)
387 break
388 ;;
389 esac
390 shift
391 done
392
a282f5a9 393 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} -- "$@"
70c7ac22
LH
394}
395
cf419828
JL
396#
397# Unregister submodules from .git/config and remove their work tree
398#
cf419828
JL
399cmd_deinit()
400{
401 # parse $args after "submodule ... deinit".
f6a52799 402 deinit_all=
cf419828
JL
403 while test $# -ne 0
404 do
405 case "$1" in
406 -f|--force)
407 force=$1
408 ;;
409 -q|--quiet)
410 GIT_QUIET=1
411 ;;
f6a52799
SB
412 --all)
413 deinit_all=t
414 ;;
cf419828
JL
415 --)
416 shift
417 break
418 ;;
419 -*)
420 usage
421 ;;
422 *)
423 break
424 ;;
425 esac
426 shift
427 done
428
a282f5a9 429 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} -- "$@"
cf419828
JL
430}
431
fb43e31f 432is_tip_reachable () (
01e1d544 433 sanitize_submodule_env &&
fb43e31f
SB
434 cd "$1" &&
435 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
436 test -z "$rev"
437)
438
439fetch_in_submodule () (
01e1d544 440 sanitize_submodule_env &&
fb43e31f
SB
441 cd "$1" &&
442 case "$2" in
443 '')
444 git fetch ;;
445 *)
6cbf454a
SB
446 shift
447 git fetch $(get_default_remote) "$@" ;;
fb43e31f
SB
448 esac
449)
450
70c7ac22 451#
211b7f19 452# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
453#
454# $@ = requested paths (default to all)
455#
23a485e3 456cmd_update()
70c7ac22 457{
5c08dbbd
JH
458 # parse $args after "submodule ... update".
459 while test $# -ne 0
460 do
461 case "$1" in
462 -q|--quiet)
2e6a30ef 463 GIT_QUIET=1
5c08dbbd 464 ;;
e84c3cf3
SB
465 -v)
466 GIT_QUIET=0
467 ;;
72c5f883 468 --progress)
c7199e3a 469 progress=1
72c5f883 470 ;;
be4d2c83 471 -i|--init)
d92a3959 472 init=1
be4d2c83 473 ;;
0060fd15
JS
474 --require-init)
475 init=1
476 require_init=1
477 ;;
06b1abb5
TK
478 --remote)
479 remote=1
480 ;;
31ca3ac3 481 -N|--no-fetch)
31ca3ac3
FF
482 nofetch=1
483 ;;
9db31bdf
NMC
484 -f|--force)
485 force=$1
486 ;;
ca2cedba 487 -r|--rebase)
32948425 488 update="rebase"
ca2cedba 489 ;;
d92a3959
MT
490 --reference)
491 case "$2" in '') usage ;; esac
492 reference="--reference=$2"
98dbe63d 493 shift
d92a3959
MT
494 ;;
495 --reference=*)
496 reference="$1"
d92a3959 497 ;;
a0ef2934
CF
498 --dissociate)
499 dissociate=1
500 ;;
42b49178 501 -m|--merge)
42b49178
JH
502 update="merge"
503 ;;
b13fd5c1 504 --recursive)
b13fd5c1
JH
505 recursive=1
506 ;;
efc5fb6a
JH
507 --checkout)
508 update="checkout"
509 ;;
abed000a
SB
510 --recommend-shallow)
511 recommend_shallow="--recommend-shallow"
512 ;;
513 --no-recommend-shallow)
514 recommend_shallow="--no-recommend-shallow"
515 ;;
275cd184
FG
516 --depth)
517 case "$2" in '') usage ;; esac
518 depth="--depth=$2"
519 shift
520 ;;
521 --depth=*)
522 depth=$1
523 ;;
2335b870
SB
524 -j|--jobs)
525 case "$2" in '') usage ;; esac
526 jobs="--jobs=$2"
527 shift
528 ;;
529 --jobs=*)
530 jobs=$1
531 ;;
132f600b
ES
532 --single-branch)
533 single_branch="--single-branch"
534 ;;
535 --no-single-branch)
536 single_branch="--no-single-branch"
537 ;;
5c08dbbd
JH
538 --)
539 shift
540 break
541 ;;
542 -*)
543 usage
544 ;;
545 *)
546 break
547 ;;
548 esac
98dbe63d 549 shift
5c08dbbd
JH
550 done
551
d92a3959
MT
552 if test -n "$init"
553 then
554 cmd_init "--" "$@" || return
555 fi
556
48308681
SB
557 {
558 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
c7199e3a 559 ${progress:+"--progress"} \
48308681
SB
560 ${wt_prefix:+--prefix "$wt_prefix"} \
561 ${prefix:+--recursive-prefix "$prefix"} \
562 ${update:+--update "$update"} \
5f50f33e 563 ${reference:+"$reference"} \
a0ef2934 564 ${dissociate:+"--dissociate"} \
48308681 565 ${depth:+--depth "$depth"} \
0060fd15 566 ${require_init:+--require-init} \
132f600b 567 $single_branch \
c7199e3a
CF
568 $recommend_shallow \
569 $jobs \
a282f5a9 570 -- \
c4c02bf1 571 "$@" || echo "#unmatched" $?
48308681 572 } | {
15ffb7cd 573 err=
9eca701f 574 while read -r quickabort sha1 just_cloned sm_path
70c7ac22 575 do
9eca701f 576 die_if_unmatched "$quickabort" "$sha1"
48308681 577
5d124f41 578 git submodule--helper ensure-core-worktree "$sm_path" || exit 1
74d4731d 579
ee69b2a9 580 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
efc5fb6a 581
44431df0 582 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 583
48308681 584 if test $just_cloned -eq 1
d851ffb9 585 then
bf2d8246
LH
586 subsha1=
587 else
14111fc4 588 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 589 git rev-parse --verify HEAD) ||
091a6eb0 590 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 591 fi
211b7f19 592
06b1abb5
TK
593 if test -n "$remote"
594 then
92bbe7cc 595 branch=$(git submodule--helper remote-branch "$sm_path")
06b1abb5
TK
596 if test -z "$nofetch"
597 then
598 # Fetch remote before determining tracking $sha1
6cbf454a 599 fetch_in_submodule "$sm_path" $depth ||
06b1abb5
TK
600 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
601 fi
14111fc4
JK
602 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
603 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5 604 git rev-parse --verify "${remote_name}/${branch}") ||
c87302bf 605 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
06b1abb5
TK
606 fi
607
496eeeb1 608 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 609 then
9db31bdf
NMC
610 subforce=$force
611 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 612 if test -z "$subsha1" && test -z "$force"
b9b378a0 613 then
9db31bdf 614 subforce="-f"
b9b378a0 615 fi
31ca3ac3
FF
616
617 if test -z "$nofetch"
618 then
e5f522d6
JL
619 # Run fetch only if $sha1 isn't present or it
620 # is not reachable from a ref.
fb43e31f 621 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 622 fetch_in_submodule "$sm_path" $depth ||
bd5e567d 623 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'; trying to directly fetch \$sha1:")"
fb43e31f
SB
624
625 # Now we tried the usual fetch, but $sha1 may
626 # not be reachable from any of the refs
627 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 628 fetch_in_submodule "$sm_path" $depth "$sha1" ||
c87302bf 629 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
630 fi
631
877449c1 632 must_die_on_failure=
32948425 633 case "$update_module" in
a2aed08b
TK
634 checkout)
635 command="git checkout $subforce -q"
636 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
637 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
638 ;;
32948425
JH
639 rebase)
640 command="git rebase"
091a6eb0
JK
641 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
642 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 643 must_die_on_failure=yes
32948425 644 ;;
42b49178
JH
645 merge)
646 command="git merge"
091a6eb0
JK
647 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
648 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 649 must_die_on_failure=yes
42b49178 650 ;;
6cb5728c
CP
651 !*)
652 command="${update_module#!}"
b08238ac
SB
653 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
654 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
655 must_die_on_failure=yes
656 ;;
32948425 657 *)
ff03d930 658 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
32948425 659 esac
70c7ac22 660
14111fc4 661 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 662 then
ff968f03 663 say "$say_msg"
877449c1
JH
664 elif test -n "$must_die_on_failure"
665 then
ff968f03 666 die_with_status 2 "$die_msg"
15ffb7cd 667 else
ff968f03 668 err="${err};$die_msg"
877449c1 669 continue
15ffb7cd 670 fi
70c7ac22 671 fi
b13fd5c1
JH
672
673 if test -n "$recursive"
674 then
75bf5e60 675 (
44431df0 676 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
3604242f 677 wt_prefix=
14111fc4 678 sanitize_submodule_env
75bf5e60 679 cd "$sm_path" &&
36141282 680 eval cmd_update
75bf5e60 681 )
15ffb7cd
FG
682 res=$?
683 if test $res -gt 0
684 then
091a6eb0 685 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
bb9d91b4 686 if test $res -ne 2
15ffb7cd 687 then
ff968f03 688 err="${err};$die_msg"
15ffb7cd
FG
689 continue
690 else
ff968f03 691 die_with_status $res "$die_msg"
15ffb7cd
FG
692 fi
693 fi
b13fd5c1 694 fi
70c7ac22 695 done
15ffb7cd
FG
696
697 if test -n "$err"
698 then
699 OIFS=$IFS
700 IFS=';'
701 for e in $err
702 do
703 if test -n "$e"
704 then
705 echo >&2 "$e"
706 fi
707 done
708 IFS=$OIFS
709 exit 1
710 fi
711 }
70c7ac22
LH
712}
713
b57e8119
DL
714#
715# Configures a submodule's default branch
716#
717# $@ = requested path
718#
719cmd_set_branch() {
720 unset_branch=false
721 branch=
722
723 while test $# -ne 0
724 do
725 case "$1" in
726 -q|--quiet)
727 # we don't do anything with this but we need to accept it
728 ;;
729 -d|--default)
730 unset_branch=true
731 ;;
732 -b|--branch)
733 case "$2" in '') usage ;; esac
734 branch=$2
735 shift
736 ;;
737 --)
738 shift
739 break
740 ;;
741 -*)
742 usage
743 ;;
744 *)
745 break
746 ;;
747 esac
748 shift
749 done
750
751 if test $# -ne 1
752 then
753 usage
754 fi
755
756 # we can't use `git submodule--helper name` here because internally, it
757 # hashes the path so a trailing slash could lead to an unintentional no match
758 name="$(git submodule--helper list "$1" | cut -f2)"
759 if test -z "$name"
760 then
761 exit 1
762 fi
763
764 test -n "$branch"; has_branch=$?
765 test "$unset_branch" = true; has_unset_branch=$?
766
767 if test $((!$has_branch != !$has_unset_branch)) -eq 0
768 then
769 usage
770 fi
771
772 if test $has_branch -eq 0
773 then
774 git submodule--helper config submodule."$name".branch "$branch"
775 else
776 git submodule--helper config --unset submodule."$name".branch
777 fi
778}
779
26b06100
DL
780#
781# Configures a submodule's remote url
782#
783# $@ = requested path, requested url
784#
785cmd_set_url() {
786 while test $# -ne 0
787 do
788 case "$1" in
789 -q|--quiet)
790 GIT_QUIET=1
791 ;;
792 --)
793 shift
794 break
795 ;;
796 -*)
797 usage
798 ;;
799 *)
800 break
801 ;;
802 esac
803 shift
804 done
805
806 if test $# -ne 2
807 then
808 usage
809 fi
810
811 # we can't use `git submodule--helper name` here because internally, it
812 # hashes the path so a trailing slash could lead to an unintentional no match
813 name="$(git submodule--helper list "$1" | cut -f2)"
814 if test -z "$name"
815 then
816 exit 1
817 fi
818
819 url="$2"
820 if test -z "$url"
821 then
822 exit 1
823 fi
824
825 git submodule--helper config submodule."$name".url "$url"
826 git submodule--helper sync ${GIT_QUIET:+--quiet} "$name"
827}
828
28f9af5d
PY
829#
830# Show commit summary for submodules in index or working tree
831#
832# If '--cached' is given, show summary between index and given commit,
833# or between working tree and given commit
834#
835# $@ = [commit (default 'HEAD'),] requested paths (default all)
836#
837cmd_summary() {
f2dc06a3 838 summary_limit=-1
d0f64dd4 839 for_status=
1c244f6e 840 diff_cmd=diff-index
f2dc06a3 841
28f9af5d
PY
842 # parse $args after "submodule ... summary".
843 while test $# -ne 0
844 do
845 case "$1" in
846 --cached)
847 cached="$1"
848 ;;
1c244f6e
JL
849 --files)
850 files="$1"
851 ;;
d0f64dd4
PY
852 --for-status)
853 for_status="$1"
854 ;;
f2dc06a3 855 -n|--summary-limit)
862ae6cd
RS
856 summary_limit="$2"
857 isnumber "$summary_limit" || usage
f2dc06a3
PY
858 shift
859 ;;
862ae6cd
RS
860 --summary-limit=*)
861 summary_limit="${1#--summary-limit=}"
862 isnumber "$summary_limit" || usage
863 ;;
28f9af5d
PY
864 --)
865 shift
866 break
867 ;;
868 -*)
869 usage
870 ;;
871 *)
872 break
873 ;;
874 esac
875 shift
876 done
bffe71f4 877
f2dc06a3
PY
878 test $summary_limit = 0 && return
879
3deea89c 880 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
881 then
882 head=$rev
caa9c3ca 883 test $# = 0 || shift
496eeeb1 884 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 885 then
14e940d7
JH
886 # before the first commit: compare with an empty tree
887 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 888 test -z "$1" || shift
28f9af5d 889 else
3deea89c 890 head="HEAD"
28f9af5d
PY
891 fi
892
1c244f6e
JL
893 if [ -n "$files" ]
894 then
895 test -n "$cached" &&
465d6a00 896 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
897 diff_cmd=diff-files
898 head=
899 fi
900
28f9af5d 901 cd_to_toplevel
091a6eb0 902 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 903 # Get modified modules cared by user
18076502 904 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 905 sane_egrep '^:([0-7]* )?160000' |
cf9e55f4 906 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
907 do
908 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
909 if test "$status" = D || test "$status" = T
910 then
6a066230 911 printf '%s\n' "$sm_path"
496eeeb1
EP
912 continue
913 fi
927b26f8 914 # Respect the ignore setting for --for-status.
915 if test -n "$for_status"
916 then
0ea306ef 917 name=$(git submodule--helper name "$sm_path")
927b26f8 918 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 919 test $status != A && test $ignore_config = all && continue
927b26f8 920 fi
28f9af5d 921 # Also show added or modified modules which are checked out
974ce807 922 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 923 printf '%s\n' "$sm_path"
28f9af5d
PY
924 done
925 )
1cb639e6 926
d0f64dd4
PY
927 test -z "$modules" && return
928
18076502 929 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 930 sane_egrep '^:([0-7]* )?160000' |
1cb639e6 931 cut -c2- |
cf9e55f4 932 while read -r mod_src mod_dst sha1_src sha1_dst status name
1cb639e6
PY
933 do
934 if test -z "$cached" &&
dda63468 935 is_zero_oid $sha1_dst
1cb639e6
PY
936 then
937 case "$mod_dst" in
938 160000)
939 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
940 ;;
941 100644 | 100755 | 120000)
942 sha1_dst=$(git hash-object $name)
943 ;;
944 000000)
945 ;; # removed
946 *)
947 # unexpected type
6ff875c5 948 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
949 continue ;;
950 esac
951 fi
952 missing_src=
953 missing_dst=
954
955 test $mod_src = 160000 &&
974ce807 956 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
957 missing_src=t
958
959 test $mod_dst = 160000 &&
974ce807 960 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 961 missing_dst=t
bffe71f4 962
44431df0 963 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
091a6eb0 964
1cb639e6
PY
965 total_commits=
966 case "$missing_src,$missing_dst" in
967 t,)
091a6eb0 968 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
969 ;;
970 ,t)
091a6eb0 971 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
972 ;;
973 t,t)
091a6eb0 974 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
975 ;;
976 *)
977 errmsg=
978 total_commits=$(
496eeeb1 979 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
980 then
981 range="$sha1_src...$sha1_dst"
982 elif test $mod_src = 160000
983 then
984 range=$sha1_src
985 else
986 range=$sha1_dst
987 fi
988 GIT_DIR="$name/.git" \
b0e621ad 989 git rev-list --first-parent $range -- | wc -l
1cb639e6 990 )
eed35595 991 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
992 ;;
993 esac
994
0586a438
SH
995 sha1_abbr_src=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_src 2>/dev/null ||
996 echo $sha1_src | cut -c1-7)
997 sha1_abbr_dst=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_dst 2>/dev/null ||
998 echo $sha1_dst | cut -c1-7)
999
1cb639e6
PY
1000 if test $status = T
1001 then
b3e73449
ÆAB
1002 blob="$(gettext "blob")"
1003 submodule="$(gettext "submodule")"
1cb639e6
PY
1004 if test $mod_dst = 160000
1005 then
091a6eb0 1006 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 1007 else
091a6eb0 1008 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
1009 fi
1010 else
091a6eb0 1011 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
1012 fi
1013 if test -n "$errmsg"
1014 then
1015 # Don't give error msg for modification whose dst is not submodule
1016 # i.e. deleted or changed to blob
1017 test $mod_dst = 160000 && echo "$errmsg"
1018 else
496eeeb1 1019 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 1020 then
f2dc06a3
PY
1021 limit=
1022 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 1023 GIT_DIR="$name/.git" \
f2dc06a3 1024 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
1025 --first-parent $sha1_src...$sha1_dst
1026 elif test $mod_dst = 160000
1027 then
1028 GIT_DIR="$name/.git" \
1029 git log --pretty='format: > %s' -1 $sha1_dst
1030 else
1031 GIT_DIR="$name/.git" \
1032 git log --pretty='format: < %s' -1 $sha1_src
1033 fi
1034 echo
1035 fi
1036 echo
3ba7407b 1037 done
28f9af5d 1038}
70c7ac22 1039#
941987a5 1040# List all submodules, prefixed with:
70c7ac22
LH
1041# - submodule not initialized
1042# + different revision checked out
1043#
1044# If --cached was specified the revision in the index will be printed
1045# instead of the currently checked out revision.
1046#
1047# $@ = requested paths (default to all)
1048#
23a485e3 1049cmd_status()
70c7ac22 1050{
5c08dbbd
JH
1051 # parse $args after "submodule ... status".
1052 while test $# -ne 0
1053 do
1054 case "$1" in
1055 -q|--quiet)
2e6a30ef 1056 GIT_QUIET=1
5c08dbbd
JH
1057 ;;
1058 --cached)
1059 cached=1
1060 ;;
64b19ffe
JH
1061 --recursive)
1062 recursive=1
1063 ;;
5c08dbbd
JH
1064 --)
1065 shift
1066 break
1067 ;;
1068 -*)
1069 usage
1070 ;;
1071 *)
1072 break
1073 ;;
1074 esac
1075 shift
1076 done
1077
a282f5a9 1078 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} -- "$@"
70c7ac22 1079}
2327f61e
DA
1080#
1081# Sync remote urls for submodules
1082# This makes the value for remote.$remote.url match the value
1083# specified in .gitmodules.
1084#
1085cmd_sync()
1086{
1087 while test $# -ne 0
1088 do
1089 case "$1" in
1090 -q|--quiet)
2e6a30ef 1091 GIT_QUIET=1
2327f61e
DA
1092 shift
1093 ;;
82f49f29
PH
1094 --recursive)
1095 recursive=1
1096 shift
1097 ;;
2327f61e
DA
1098 --)
1099 shift
1100 break
1101 ;;
1102 -*)
1103 usage
1104 ;;
1105 *)
1106 break
1107 ;;
1108 esac
1109 done
e7849a96 1110
a282f5a9 1111 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
2327f61e 1112}
70c7ac22 1113
f6f85861
SB
1114cmd_absorbgitdirs()
1115{
1116 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1117}
1118
5c08dbbd
JH
1119# This loop parses the command line arguments to find the
1120# subcommand name to dispatch. Parsing of the subcommand specific
1121# options are primarily done by the subcommand implementations.
1122# Subcommand specific options such as --branch and --cached are
1123# parsed here as well, for backward compatibility.
1124
1125while test $# != 0 && test -z "$command"
70c7ac22
LH
1126do
1127 case "$1" in
26b06100 1128 add | foreach | init | deinit | update | set-branch | set-url | status | summary | sync | absorbgitdirs)
5c08dbbd 1129 command=$1
70c7ac22
LH
1130 ;;
1131 -q|--quiet)
2e6a30ef 1132 GIT_QUIET=1
70c7ac22 1133 ;;
ecda0723
SV
1134 -b|--branch)
1135 case "$2" in
1136 '')
1137 usage
1138 ;;
1139 esac
1140 branch="$2"; shift
1141 ;;
70c7ac22 1142 --cached)
28f9af5d 1143 cached="$1"
70c7ac22
LH
1144 ;;
1145 --)
1146 break
1147 ;;
1148 -*)
1149 usage
1150 ;;
1151 *)
1152 break
1153 ;;
1154 esac
1155 shift
1156done
1157
5c08dbbd 1158# No command word defaults to "status"
af9c9f97
RR
1159if test -z "$command"
1160then
1161 if test $# = 0
1162 then
1163 command=status
1164 else
1165 usage
1166 fi
1167fi
5c08dbbd 1168
b57e8119
DL
1169# "-b branch" is accepted only by "add" and "set-branch"
1170if test -n "$branch" && (test "$command" != add || test "$command" != set-branch)
5c08dbbd 1171then
ecda0723 1172 usage
5c08dbbd
JH
1173fi
1174
28f9af5d 1175# "--cached" is accepted only by "status" and "summary"
496eeeb1 1176if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1177then
70c7ac22 1178 usage
5c08dbbd
JH
1179fi
1180
b57e8119 1181"cmd_$(echo $command | sed -e s/-/_/g)" "$@"